
/*
 * This file was automatically generated by sdbus-c++-xml2cpp; DO NOT EDIT!
 */

#ifndef __sdbuscpp__firewalld_proxy_sdbus_1_FirewallD1_Config_IpSet_Proxy_h__proxy__H__
#define __sdbuscpp__firewalld_proxy_sdbus_1_FirewallD1_Config_IpSet_Proxy_h__proxy__H__

#include <sdbus-c++/sdbus-c++.h>
#include <string>
#include <tuple>

namespace org {
namespace fedoraproject {
namespace FirewallD1 {
namespace config {

class ipset_proxy
{
public:
    static constexpr const char* INTERFACE_NAME = "org.fedoraproject.FirewallD1.config.ipset";

protected:
    ipset_proxy(sdbus::IProxy& proxy)
        : proxy_(&proxy)
    {
        proxy_->uponSignal("Updated").onInterface(INTERFACE_NAME).call([this](const std::string& name){ this->onUpdated(name); });
        proxy_->uponSignal("Removed").onInterface(INTERFACE_NAME).call([this](const std::string& name){ this->onRemoved(name); });
        proxy_->uponSignal("Renamed").onInterface(INTERFACE_NAME).call([this](const std::string& name){ this->onRenamed(name); });
    }

    ipset_proxy(const ipset_proxy&) = delete;
    ipset_proxy& operator=(const ipset_proxy&) = delete;
    ipset_proxy(ipset_proxy&&) = default;
    ipset_proxy& operator=(ipset_proxy&&) = default;

    ~ipset_proxy() = default;

    virtual void onUpdated(const std::string& name) = 0;
    virtual void onRemoved(const std::string& name) = 0;
    virtual void onRenamed(const std::string& name) = 0;

public:
    sdbus::Struct<std::string, std::string, std::string, std::string, std::map<std::string, std::string>, std::vector<std::string>> getSettings()
    {
        sdbus::Struct<std::string, std::string, std::string, std::string, std::map<std::string, std::string>, std::vector<std::string>> result;
        proxy_->callMethod("getSettings").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void update(const sdbus::Struct<std::string, std::string, std::string, std::string, std::map<std::string, std::string>, std::vector<std::string>>& settings)
    {
        proxy_->callMethod("update").onInterface(INTERFACE_NAME).withArguments(settings);
    }

    void loadDefaults()
    {
        proxy_->callMethod("loadDefaults").onInterface(INTERFACE_NAME);
    }

    void remove()
    {
        proxy_->callMethod("remove").onInterface(INTERFACE_NAME);
    }

    void rename(const std::string& name)
    {
        proxy_->callMethod("rename").onInterface(INTERFACE_NAME).withArguments(name);
    }

    std::string getVersion()
    {
        std::string result;
        proxy_->callMethod("getVersion").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setVersion(const std::string& version)
    {
        proxy_->callMethod("setVersion").onInterface(INTERFACE_NAME).withArguments(version);
    }

    std::string getShort()
    {
        std::string result;
        proxy_->callMethod("getShort").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setShort(const std::string& short_)
    {
        proxy_->callMethod("setShort").onInterface(INTERFACE_NAME).withArguments(short_);
    }

    std::string getDescription()
    {
        std::string result;
        proxy_->callMethod("getDescription").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setDescription(const std::string& description)
    {
        proxy_->callMethod("setDescription").onInterface(INTERFACE_NAME).withArguments(description);
    }

    std::string getType()
    {
        std::string result;
        proxy_->callMethod("getType").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setType(const std::string& ipset_type)
    {
        proxy_->callMethod("setType").onInterface(INTERFACE_NAME).withArguments(ipset_type);
    }

    std::map<std::string, std::string> getOptions()
    {
        std::map<std::string, std::string> result;
        proxy_->callMethod("getOptions").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setOptions(const std::map<std::string, std::string>& options)
    {
        proxy_->callMethod("setOptions").onInterface(INTERFACE_NAME).withArguments(options);
    }

    void addOption(const std::string& key, const std::string& value)
    {
        proxy_->callMethod("addOption").onInterface(INTERFACE_NAME).withArguments(key, value);
    }

    void removeOption(const std::string& key)
    {
        proxy_->callMethod("removeOption").onInterface(INTERFACE_NAME).withArguments(key);
    }

    bool queryOption(const std::string& key, const std::string& value)
    {
        bool result;
        proxy_->callMethod("queryOption").onInterface(INTERFACE_NAME).withArguments(key, value).storeResultsTo(result);
        return result;
    }

    std::vector<std::string> getEntries()
    {
        std::vector<std::string> result;
        proxy_->callMethod("getEntries").onInterface(INTERFACE_NAME).storeResultsTo(result);
        return result;
    }

    void setEntries(const std::vector<std::string>& entries)
    {
        proxy_->callMethod("setEntries").onInterface(INTERFACE_NAME).withArguments(entries);
    }

    void addEntry(const std::string& entry)
    {
        proxy_->callMethod("addEntry").onInterface(INTERFACE_NAME).withArguments(entry);
    }

    void removeEntry(const std::string& entry)
    {
        proxy_->callMethod("removeEntry").onInterface(INTERFACE_NAME).withArguments(entry);
    }

    bool queryEntry(const std::string& entry)
    {
        bool result;
        proxy_->callMethod("queryEntry").onInterface(INTERFACE_NAME).withArguments(entry).storeResultsTo(result);
        return result;
    }

public:
    std::string name()
    {
        return proxy_->getProperty("name").onInterface(INTERFACE_NAME);
    }

    std::string filename()
    {
        return proxy_->getProperty("filename").onInterface(INTERFACE_NAME);
    }

    std::string path()
    {
        return proxy_->getProperty("path").onInterface(INTERFACE_NAME);
    }

    bool default_()
    {
        return proxy_->getProperty("default").onInterface(INTERFACE_NAME);
    }

    bool builtin()
    {
        return proxy_->getProperty("builtin").onInterface(INTERFACE_NAME);
    }

private:
    sdbus::IProxy* proxy_;
};

}}}} // namespaces

#endif
